; NO STACK USAGE

include ht48e30.inc

include 7segglob.inc

public _CGRAM
public _init7seg
public _cls7seg
public _findk
public findk0
public _DISP_F
public _LAST_K

dseck 	.section    'data'
findk0	db ?
Klctr	db ?

dsec 	.section    'data'

_CGRAM	db DIGITS dup(?)
CGIDX	db ?
_DISP_F	db ?
DIGIT	db ?
BLNKTMR	db ?
ANIMTMR	db ?
_LAST_K	db 2 dup(?)
tmp		db ?
softstack	db 4 dup(?)



BLNKMSK	equ 1 SHL BLNKNG		; toggle BLNKNG bit


int		.section at 8 'code'

		jmp T0HND


code7 	.section INPAGE 'CODE'
T0HND:	mov softstack,A				; salva A
		mov A,STATUS
		mov softstack[1],A			; salva STATUS
		mov A,MP0
		mov softstack[2],A			; salva MP0
		mov A,TBLP
		mov softstack[3],A			; salva MP0
		mov A,DIGSOFF
	IFDEF COMMONANODE
		cpl ACC
		orm A,dig_data
	ELSE
		andm A,dig_data
	ENDIF

segoff:	
	IFDEF COMMONANODE
		set seg_data
	ELSE
		clr seg_data
	ENDIF
		snz _DISP_F.BEEP
		jmp NoBeep
		sz _DISP_F.BLNKNG
		set BUZZER
		snz _DISP_F.BLNKNG
		clr BUZZER
NoBeep:	snz _DISP_F.DISPON
		jmp NoShow
		mov A,OFFSET _CGRAM		; CGRAM base
		dec ACC					; -1 (offset 1..n)
		add A,CGIDX 			; + offset
		mov MP0,A				; indirecto
		mov A,IAR0
		mov tmp,A
		snz ACC.7
		jmp Noblink
		snz _DISP_F.BLNKNG
		jmp NoShow
Noblink:
	IFDEF USELEDS
		sz	DIGIT.0				; skip decoding if showing LEDs (PC.0)
		jmp nodecode
	ENDIF
		and A,03Fh				; remove blink and dp bits
		add A,OFFSET BBCD27S	; point into table
		mov TBLP,A
		tabrdc ACC		 			
		sz tmp.6
		set ACC.dp
nodecode:
	IFDEF COMMONANODE
		cpl ACC
	ENDIF
		mov seg_data,A
NoShow:	mov A,DIGIT
	IFDEF COMMONANODE
		cpl ACC
		andm A,dig_data
	ELSE
		orm A,dig_data
	ENDIF
		mov A,kbd_data					; get returns
	IFDEF COMMONANODE
		cpl ACC
	ENDIF
		and A,0F0h						; only high nibble
		sz Z
		jmp nokey
		or A,DIGIT						; add scan
		orm A,_LAST_K[1]				; store
nokey:	set _DISP_F.DSYNC
		sdz CGIDX
		jmp nofrs
; Frame sync
		mov A,_LAST_K[1]
		mov _LAST_K,A
		clr _LAST_K[1]
		mov A,DIGITS
		mov CGIDX,A
		mov A,LMOST
		mov DIGIT,A
		set _DISP_F.FSYNC
		sdz ANIMTMR
		jmp DMF_l1
		mov A,ANIMTM
		mov ANIMTMR,A
		set _DISP_F.ASYNC
DMF_l1:	sdz BLNKTMR
		jmp DMF_dn
		mov A,BLNKTM
		mov BLNKTMR,A
		mov A,BLNKMSK
		xorm A,_DISP_F
DMF_dn:	jmp DispDn
nofrs:	rrc DIGIT
DispDn:
		mov A,softstack[3]
		mov TBLP,A					; recupera MP0
		mov A,softstack[2]
		mov MP0,A					; recupera MP0
		mov A,softstack[1]
		mov STATUS,A				; recupera STATUS
		mov A,softstack				; recupera A
		reti

; CGRAM data: bit7 -> blink, bit6 -> dp, bits 0-5 -> character
;bit assignment, 7-0: .gfedcab

BBCD27S: DW 03Fh,006h,05Bh,04Fh,066h,06Dh,07Dh,007h
        DW 07Fh,06Fh,07Ch,05Eh,054h,071h,079h,07Dh
        DW 073h,040h,008h,004h,000h,038h,001h,077h
        DW 050h,076h,030h,006h,03Eh

;Charset: 0-9
;10=b; 11=d; 12=n; 13=F; 14=E; 15=G; 16=P
;17=-; 18=_; 19=i; 20=Blank; 21=L; 22=-(up)
;23=A; 24=r; 25=H; 26=|(left); 27=|; 28=U


code7k 	.section INPAGE 'CODE'
_findk:	mov A,OFFSET tabk
		mov TBLP,A
		mov A,16
		mov Klctr,A
fkl:	tabrdc ACC
		xor A,findk0			; get key
		sz Z
		jmp kf
		inc TBLP
		sdz Klctr
		jmp fkl
		ret A,0FFh
kf:		mov A,TBLP
		sub A,OFFSET tabk
		ret

tabk:	DW K0,K1,K2,K3,K4,K5,K6,K7,K8,K9,KF1,KF2,KF3,KF4,KA,KN


code7_	.section	'code'					

_init7seg:
		clr _DISP_F
		mov A,BLNKTM
		mov BLNKTMR,A
		mov A,ANIMTM+1
		mov ANIMTMR,A
		mov A,DIGITS
		mov CGIDX,A
		mov A,LMOST
		mov DIGIT,A
		mov A,178					; 64us*78=4,992ms => 256-78=178
		mov TMR,A
		mov A,10010111b				; timer, prescaler=256 (4MHz/256=>64us)
		mov TMRC,A
_cls7seg:
		mov A,20
		mov _CGRAM,A
		mov _CGRAM[1],A
		mov _CGRAM[2],A
		mov _CGRAM[3],A
		ret

